## net.sf.saxon.value
Class TimeValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.CalendarValue
                  net.sf.saxon.value.TimeValue

All Implemented Interfaces:
  java.io.Serializable, java.lang.Comparable, PullEvent, SequenceIterable, GroundedValue, Item, ValueRepresentation, ConversionResult

    public final class TimeValue

extends CalendarValue
implements java.lang.Comparable

A value of type xs:time

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.value.CalendarValue
`NO_TIMEZONE`

Fields inherited from class net.sf.saxon.value.AtomicValue
`typeLabel`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`TimeValue(byte hour, byte minute, byte second, int microsecond, int tz)` Construct a time value given the hour, minute, second, and microsecond components.
`TimeValue(java.util.GregorianCalendar calendar, int tz)` Constructor: create a time value given a Java calendar object

Method Summary
`CalendarValue` `add(DurationValue duration)` Add a duration to a dateTime
`CalendarValue` `adjustTimezone(int timezone)` Return a new time with the same normalized value, but in a different timezone.
`int` `compareTo(CalendarValue other, XPathContext context)` Compare the value to another dateTime value
`int` `compareTo(java.lang.Object other)` Compare the value to another dateTime value
`ConversionResult` `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`AtomicValue` `copyAsSubType(AtomicType typeLabel)` Make a copy of this time value, but with a different type label
`boolean` `equals(java.lang.Object other)` The equals() methods on atomic values is defined to follow the semantics of eq when applied to two atomic values.
`java.util.GregorianCalendar` `getCalendar()` Get a Java Calendar object corresponding to this time, on a reference date
`java.lang.CharSequence` `getCanonicalLexicalRepresentation()` Get the canonical lexical representation as defined in XML Schema.
`ComparisonKey` `getComparisonKey(XPathContext context)` Get a comparison key for this value.
`AtomicValue` `getComponent(int component)` Get a component of the value.
`byte` `getHour()` Get the hour component, 0-23
`int` `getMicrosecond()` Get the microsecond component, 0-999999
`byte` `getMinute()` Get the minute component, 0-59
`BuiltInAtomicType` `getPrimitiveType()` Determine the primitive type of the value.
`java.lang.Comparable` `getSchemaComparable()` Get a Comparable value that implements the XML Schema ordering comparison semantics for this value.
`byte` `getSecond()` Get the second component, 0-59
`java.lang.CharSequence` `getStringValueCS()` Convert to string
`int` `hashCode()`
`static ConversionResult` `makeTimeValue(java.lang.CharSequence s)` Static factory method: create a time value from a supplied string, in ISO 8601 format
`DayTimeDurationValue` `subtract(CalendarValue other, XPathContext context)` Determine the difference between two points in time, as a duration
`DateTimeValue` `toDateTime()` Convert to a DateTime value.

Methods inherited from class net.sf.saxon.value.CalendarValue
`adjustTimezone, appendTimezone, appendTimezone, getStringValue, getTimezoneInMinutes, getXPathComparable, hasTimezone, removeTimezone, setTimezoneInMinutes`

Methods inherited from class net.sf.saxon.value.AtomicValue
`asAtomic, checkPermittedContents, convert, convert, effectiveBooleanValue, getCardinality, getItemType, getLength, getTypedValue, getTypeLabel, isNaN, itemAt, iterate, process, setTypeLabel, subsequence, toString`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convertToJava, fromItem, getIterator, iterate, makeQNameValue, reduce, stringToNumber`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### TimeValue

    public TimeValue(byte hour,
                     byte minute,
                     byte second,
                     int microsecond,
                     int tz)

  Construct a time value given the hour, minute, second, and microsecond components. This constructor performs no validation.

  Parameters:
    `hour` - the hour value, 0-23
    `minute` - the minutes value, 0-59
    `second` - the seconds value, 0-59
    `microsecond` - the number of microseconds, 0-999999
    `tz` - the timezone displacement in minutes from UTC. Supply the value `CalendarValue.NO_TIMEZONE` if there is no timezone component.

### TimeValue

    public TimeValue(java.util.GregorianCalendar calendar,
                     int tz)

  Constructor: create a time value given a Java calendar object

  Parameters:
    `calendar` - holds the date and time
    `tz` - the timezone offset in minutes, or NO_TIMEZONE indicating that there is no timezone

Method Detail

### makeTimeValue

    public static ConversionResult makeTimeValue(java.lang.CharSequence s)
                                          throws XPathException

  Static factory method: create a time value from a supplied string, in ISO 8601 format

  Parameters:
    `s` - the time in the lexical format hh:mm:ss[.ffffff] followed optionally by timezone in the form [+-]hh:mm or Z
  Returns:
    either a TimeValue corresponding to the xs:time, or a ValidationFailure if the supplied value was invalid
  Throws:
    `XPathException`

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Specified by:
    `getPrimitiveType` in class `AtomicValue`
  Returns:
    the primitive type

### getHour

    public byte getHour()

  Get the hour component, 0-23

  Returns:
    the hour

### getMinute

    public byte getMinute()

  Get the minute component, 0-59

  Returns:
    the minute

### getSecond

    public byte getSecond()

  Get the second component, 0-59

  Returns:
    the second

### getMicrosecond

    public int getMicrosecond()

  Get the microsecond component, 0-999999

  Returns:
    the microseconds

### convertPrimitive

    public ConversionResult convertPrimitive(BuiltInAtomicType requiredType,
                                             boolean validate,
                                             XPathContext context)

  Convert to target data type

  Specified by:
    `convertPrimitive` in class `AtomicValue`
  Parameters:
    `requiredType` - an integer identifying the required atomic type
    `context` - XPath dynamic evaluation context
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    an AtomicValue, a value of the required type; or an ErrorValue

### getStringValueCS

    public java.lang.CharSequence getStringValueCS()

  Convert to string

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Overrides:
    `getStringValueCS` in class `AtomicValue`
  Returns:
    ISO 8601 representation, in the localized timezone (the timezone held within the value).
  See Also:
    `Item.getStringValue()`

### getCanonicalLexicalRepresentation

    public java.lang.CharSequence getCanonicalLexicalRepresentation()

  Get the canonical lexical representation as defined in XML Schema. This is not always the same as the result of casting to a string according to the XPath rules. For an xs:time it is the time adjusted to UTC

  Overrides:
    `getCanonicalLexicalRepresentation` in class `Value`
  Returns:
    the canonical lexical representation if defined in XML Schema

### toDateTime

    public DateTimeValue toDateTime()

  Convert to a DateTime value. The date components represent a reference date, as defined in the spec for comparing times.

  Specified by:
    `toDateTime` in class `CalendarValue`
  Returns:
    the equivalent DateTimeValue

### getCalendar

    public java.util.GregorianCalendar getCalendar()

  Get a Java Calendar object corresponding to this time, on a reference date

  Specified by:
    `getCalendar` in class `CalendarValue`
  Returns:
    A Calendar object representing the date and time. Note that Java can only represent the time to millisecond precision, and that it does not support the full range of timezones required by XPath (-14:00 to +14:00)

### copyAsSubType

    public AtomicValue copyAsSubType(AtomicType typeLabel)

  Make a copy of this time value, but with a different type label

  Specified by:
    `copyAsSubType` in class `AtomicValue`
  Parameters:
    `typeLabel` - the new type label. This must be a subtype of xs:time.
  Returns:
    the copied value

### adjustTimezone

    public CalendarValue adjustTimezone(int timezone)

  Return a new time with the same normalized value, but in a different timezone. This is called only for a TimeValue that has an explicit timezone

  Specified by:
    `adjustTimezone` in class `CalendarValue`
  Parameters:
    `timezone` - the new timezone offset, in minutes
  Returns:
    the time in the new timezone. This will be a new TimeValue unless no change was required to the original value

### getComponent

    public AtomicValue getComponent(int component)
                             throws XPathException

  Get a component of the value. Returns null if the timezone component is requested and is not present.

  Overrides:
    `getComponent` in class `AtomicValue`
  Parameters:
    `component` - identifies the required component, as a constant defined in class `Component`, for example `Component.HOURS`
  Returns:
    the value of the requested component of this value
  Throws:
    `XPathException`

### compareTo

    public int compareTo(java.lang.Object other)

  Compare the value to another dateTime value

  Specified by:
    `compareTo` in interface `java.lang.Comparable`
  Parameters:
    `other` - The other dateTime value
  Returns:
    negative value if this one is the earler, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
  Throws:
    `java.lang.ClassCastException` - if the other value is not a TimeValue (the parameter is declared as Object to satisfy the Comparable interface)

### compareTo

    public int compareTo(CalendarValue other,
                         XPathContext context)
                  throws NoDynamicContextException

  Compare the value to another dateTime value

  Specified by:
    `compareTo` in class `CalendarValue`
  Parameters:
    `other` - The other dateTime value
    `context` - the XPath dynamic evaluation context
  Returns:
    negative value if this one is the earler, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
  Throws:
    `java.lang.ClassCastException` - if the other value is not a DateTimeValue (the parameter is declared as Object to satisfy the Comparable interface)
    `NoDynamicContextException` - if the implicit timezone is required and is not available (because the function is called at compile time)

### getSchemaComparable

    public java.lang.Comparable getSchemaComparable()

  Description copied from class: `AtomicValue`
  Get a Comparable value that implements the XML Schema ordering comparison semantics for this value. An implementation must be provided for all atomic types.

  In the case of data types that are partially ordered, the returned Comparable extends the standard semantics of the compareTo() method by returning the value `Value.INDETERMINATE_ORDERING` when there is no defined order relationship between two given values. This value is also returned when two values of different types are compared.

  Specified by:
    `getSchemaComparable` in class `AtomicValue`
  Returns:
    a Comparable that follows XML Schema comparison rules

### getComparisonKey

    public ComparisonKey getComparisonKey(XPathContext context)
                                   throws NoDynamicContextException

  Get a comparison key for this value. Two values are equal if and only if they their comparison keys are equal

  Specified by:
    `getComparisonKey` in class `CalendarValue`
  Parameters:
    `context` - XPath dynamic context
  Returns:
    a comparison key
  Throws:
    `NoDynamicContextException` - if the implicit timezone is required and is not available

### equals

    public boolean equals(java.lang.Object other)

  Description copied from class: `AtomicValue`
  The equals() methods on atomic values is defined to follow the semantics of eq when applied to two atomic values. When the other operand is not an atomic value, the result is undefined (may be false, may be an exception). When the other operand is an atomic value that cannot be compared with this one, the method must throw a ClassCastException.

  The hashCode() method is consistent with equals().

  Specified by:
    `equals` in class `AtomicValue`
  Parameters:
    `other` - the other value
  Returns:
    true if the other operand is an atomic value and the two values are equal as defined by the XPath eq operator

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `java.lang.Object`

### add

    public CalendarValue add(DurationValue duration)
                      throws XPathException

  Add a duration to a dateTime

  Specified by:
    `add` in class `CalendarValue`
  Parameters:
    `duration` - the duration to be added (may be negative)
  Returns:
    the new date
  Throws:
    `XPathException` - if the duration is an xs:duration, as distinct from a subclass thereof

### subtract

    public DayTimeDurationValue subtract(CalendarValue other,
                                         XPathContext context)
                                  throws XPathException

  Determine the difference between two points in time, as a duration

  Overrides:
    `subtract` in class `CalendarValue`
  Parameters:
    `other` - the other point in time
    `context` - XPath dynamic evaluation context
  Returns:
    the duration as an xs:dayTimeDuration
  Throws:
    `XPathException` - for example if one value is a date and the other is a time

Copyright (c) Saxonica Limited. All rights reserved.